#!/usr/bin/python3
# _*_ coding:utf-8 _*_

# @Author : tengteng.li
# @Time   : 2022/06/20

import psutil
import getpass
import time
import os

# 时间戳转换为时间
def timestamp_to_time(timestamp):
    time_struct = time.localtime(timestamp)
    return time.strftime('%Y-%m-%d %H:%M:%S', time_struct)

########################### 获取系统状态信息 ###########################
print(" System Info ".center(100, '='))
# 统计工作站运行时间，单位小时
open_computer_time = {"start": timestamp_to_time(psutil.boot_time())}
run_times = ("%.2f" % ((time.time() - psutil.boot_time()) / 60 / 60))
print('System boot time: ' + run_times + 'H')

# 获取当前登陆账号名称
username = getpass.getuser()
print('Login Account: ' + username)

# 获取系统CPU信息
# CPU使用率
cpu_in_use = psutil.cpu_percent(interval=0.3)
# 系统负载
loadavg = psutil.getloadavg()
print('CPU Usage: ' + str(cpu_in_use) + '%')

# 获取系统内存信息
# 内存使用率
mem_info = psutil.virtual_memory()
mem_percent = mem_info.percent
print('Memory Usage: ' + str(mem_percent) + '%')

# 获取系统磁盘信息
# 磁盘使用率
root_percent = psutil.disk_usage('/').percent
print('System Disk Dsage: ' + str(root_percent) + '%')
if root_percent > 85:
    print('\033[0;31;43mThe system disk usage has exceeded %s%%. Please clean up unnecessary data.\033[0m' %(root_percent))

if os.path.exists('/ssd'):
    ssd_percent = psutil.disk_usage('/ssd').percent
    print('SSD Disk Dsage: ' + str(ssd_percent) + '%')
    if ssd_percent > 85:
        print('\033[0;31;43mThe ssd disk usage has exceeded %s%%. Please clean up unnecessary data.\033[0m' % (ssd_percent))

if os.path.exists('/data'):
    data_percent = psutil.disk_usage('/data').percent
    print('DATA Disk Dsage: ' + str(data_percent) + '%')
    if data_percent > 90:
        print('\033[0;31;43mThe data disk usage has exceeded %s%%. Please clean up unnecessary data.\033[0m' %(data_percent))
